# Pathside Box

Two channels of IO transducers on a box, self modulating feedback.

This is the code that runs on the Raspberry Pi mounted in the box.

Basic idea: several bandpass filters and envelope followers ride the feedback. Pitch tracking occasionally finds a new root, and eventually I'll add a little more variety regarding the tilt of the filters.

## Scripts

In addition to the pure-data (purr-data) patch, there are some scripts and a systemd unit file.

* `performance-hacks.sh` - some performance hacks for running jackd on headless Raspberry Pi.
* `start-jack.sh` - starts jack
* `run-for-duration.sh` - runs the patch for the specified duration (passed to `sleep`, so phrases like `5h` work) or 10 minutes if not specified.
* `service-start.sh` - passes the value of `/home/pi/pathside-box` to `run-for-duration.sh`, which is called with the user pi. This is the script that the systemd service starts.

The systemd service is designed to call `service-start.sh` on boot _only if the `/home/pi/pathside-box` file exists._ This restriction is in place so that the patch only runs on specified boots.

**To install the systemd file:**

```
systemctl link pathside-box.service
systemctl enable pathside-box.service
```
