#!/usr/bin/env bash
#
# Performance hacks to improve audio on RPi. Adapted from 802.11.
# Really only needs to be called once per boot but does no harm to call again.
#
# Other hacks:
#
# bypass using DBus - must be run in same shell as jackd:
# ```
# export JACK_NO_AUDIO_RESERVATION=1 
# ```
#
# tricks for working with DBus without an x session:
# ```
# export DISPLAY=:0
# export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/dbus/system_bus_socket
# export `su pi -c "dbus-launch | grep ADDRESS"`
# export `su pi -c "dbus-launch | grep PID"`
# ```
#
# add these lines to /etc/security/limits.conf:
#
# ```
# @audio - rtprio 90          # maximum realtime priority
# @audio - memlock unlimited  # maximum locked-in-memory address space (KB)
# @audio - nice -10
# pi      - rtprio 90
# pi      - memlock unlimited
# pi      - nice -10
# ```

if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root" 
   exit 1
fi

# performance hacks
mount -o remount,size=128M /dev/shm
for cpu in /sys/devices/system/cpu/cpu[0-9]*; do
	echo -n performance > $cpu/cpufreq/scaling_governor;
done
