#! /usr/bin/env bash
#
# Start jack with these settings, then run the patch for $1 or 10 minutes

# make sure we're in the right directory
DIR="$( cd "$(dirname "$0")" ; pwd -P )"
pushd $DIR

DUR=10m
if [ -n "$1" ]; then
    DUR=$1
fi

export SAMPLE_RATE=96000
export PERIOD=512
export N_PERIODS=4

sudo ./start-jack.sh

echo "starting pathside box for $DUR with $N_PERIODS x $PERIOD periods at $SAMPLE_RATE Hz"
purr-data -jack -rt -nogui -channels 2 -autopatch -path "/home/pi" -open ./main.pd -send "pd dsp 1" -send "sr $SAMPLE_RATE" -send "bs $PERIOD" -send "periods $N_PERIODS" 2>&1 | egrep -v "watchdog|verbose" &
sleep "$DUR"

killall purr-data
killall jackd

popd
echo "Done."
